/*
   This program parses and then evaluates strings from Language-9.
*/

public class Language_9_Examples
{
   public static void main(String[] args)
   {
      // IMPORTANT: Set this to 0 or 1 depending on whether you need
      // to see all of the interpreter's debugging information.
      Evaluate.DEBUG = 1;

      String[] programs =
      {
         "( prog " +
            "( var x1 10 ) " +
            "( var x2 ( sym ok ) ) " +
            "( print ( var x3 ( list x1 100 true x2 ( list 1 2 3 ) w ) ) ) " +
            "( print ( empty ( cdr x3 ) ) ) " +
            "( print ( car x3 ) ) " +
            "( var x4 ( cons ( sym pear ) ( cdr x3 ) ) ) )",

         "( prog ( cons 5 ( cdr ( cdr ( list 1 2 ) ) ) ) )",

         "( prog ( cons ( sym 1a ) ( cons ( list 2a 2b 02c 02 ) ( cons 03 ( list a b c ) ) ) ) )",

         "( prog ( list 1 ( list 2 3 4 5 ) ) )",

         "( prog ( cons 1 ( list 2 3 4 5 ) ) )",

         "( prog " +
           "( fun map " +
               "( lambda  op lst " +  // op is a function, lst is a list
                 "( if ( empty lst ) " +
                      " lst " +
                      "( cons ( apply op ( car lst ) ) ( apply map op ( cdr lst ) ) ) ) ) ) " +
           "( print ( apply map ( lambda x ( + x 10 ) ) ( list 1 2 3 4 5 6 7 ) ) ) " +
           "( print ( apply map ( lambda x ( * x 10 ) ) ( list 1 2 3 4 5 6 7 ) ) ) )",

         "( prog " +
           "( fun reduce " +
               "( lambda  op lst " +  // op is a function, lst is a non-empty list
                 "( if ( empty ( cdr lst ) ) " +
                      "( car lst ) " +
                      "( apply op ( car lst ) ( apply reduce op ( cdr lst ) ) ) ) ) ) " +
           "( print ( apply reduce ( lambda x y ( + x y ) ) ( list 1 2 3 4 5 6 7 ) ) ) " +
           "( print ( apply reduce ( lambda x y ( * x y ) ) ( list 1 2 3 4 5 6 7 ) ) ) )",

         "( prog " +
           "( fun map " +
               "( lambda  op lst " +  // op is a function, lst is a list
                 "( if ( empty lst ) " +
                      " lst " +
                      "( cons ( apply op ( car lst ) ) ( apply map op ( cdr lst ) ) ) ) ) ) " +
           "( fun reduce " +
               "( lambda  op lst " +  // op is a function, lst is a non-empty list
                 "( if ( empty ( cdr lst ) ) " +
                      "( car lst ) " +
                      "( apply op ( car lst ) ( apply reduce op ( cdr lst ) ) ) ) ) ) " +
           "( print ( var nums ( list 1 2 3 4 5 6 7 ) ) ) " +
           "( print ( apply reduce ( lambda x y ( + x y ) ) ( apply map ( lambda x ( + x 10 ) ) nums ) ) ) " +
           "( sym done ) )"
      };


      int i = 0;
      for (i = 0; i < programs.length; i++)
      {
         System.out.println(i + " =============================================");

         // Print the expression.
         //System.out.println( programs[i] + "\n" );

         // Build the abstract syntax tree that represents the expression.
         try
         {
            Tree ast = BuildTree.buildTree( programs[i] );

            // Print the AST as an S-expression
            //System.out.println( ast + "\n" );

            // Pretty-print the abstract syntax tree.
            System.out.println( PrettyPrinter.prettyPrint( ast ) + "\n" );

            // Print the infix version of the expression.
            System.out.println( AST2infix.ast2infix( ast ) + "\n" );

            // Create dot and png files from the AST.
            if(true)
            try
            {
               // Create the (empty) dot file.
               String baseName = String.format("Language_9.%02d", i);
               java.io.PrintWriter out = new java.io.PrintWriter(
                                            new java.io.File(baseName + ".dot") );
               // Put dot commands into the dot file
               out.println( Tree2dot_ver1.tree2dot(ast) + "\n" );
               out.close();
               // Create a command line for running dot.exe.
               String[] cmd = {"C:\\graphviz-2.38\\release\\bin\\dot.exe",
                               "-Tpng",
                               baseName + ".dot",
                               "-o",
                               baseName + ".png"};
               // Execute the command line.
               java.lang.Runtime.getRuntime().exec(cmd);
            }
            catch (Exception e)
            {
               System.out.println( e );
            }

            // Evaluate the expression (interpret the AST).
            Value value = Evaluate.eval( ast );
            System.out.println( "result = " + value + "\n" );
         }
         catch (TokenizeException e)
         {
            System.out.println(e);
          //e.printStackTrace();
         }
         catch (ParseException e)
         {
            System.out.println(e);
          //e.printStackTrace();
         }
         catch (EvalException e)
         {
            System.out.println(e);
          //e.printStackTrace();
         }
      }
   }//main()
}//Language_9_Examples
